from test_sam import BaseTest, one_app_index, assert_single_application


class TestHooks(BaseTest):

    def test_remove_hook_good(self):
        pre_remove_content = '#!/bin/sh\nexit 0'

        self.create_app_version('test-app', '1.0', pre_remove=pre_remove_content)
        self.create_release('release-1.0', one_app_index(), 'test-app=1.0')

        self.sam.update('release-1.0')

        self.sam.install('test-app')

        # self.sam.remove('test-app')

        applications = self.sam.list()
        assert_single_application(applications, 'test-app', 'test app', '1.0', None)


    # def test_remove_hook_missing(self):
    #     self.create_app_version('test-app', '1.0')
    #     self.create_release('release-1.0', one_app_index(), 'test-app=1.0')
    #     self.sam.update('release-1.0')
    #
    #     self.sam.install('test-app')
    #
    #     self.sam.remove('test-app')
    #
    #     applications = self.sam.list()
    #     assert_single_application(applications, 'test-app', 'test app', '1.0', None)

    def _test_remove_hook_bad(self):
        pre_remove_content = '#!/bin/sh\nexit 1'

        self.create_app_version('test-app', '1.0', pre_remove=pre_remove_content)
        self.create_release('release-1.0', one_app_index(), 'test-app=1.0')

        self.sam.update('release-1.0')

        self.sam.install('test-app')

        try:
            self.sam.remove('test-app')
            assert False
        except Exception, e:
            assert True

        applications = self.sam.list()
        assert_single_application(applications, 'test-app', 'test app', '1.0', '1.0')

    def _test_install_hook_bad(self):
        post_install_content = '#!/bin/sh\nexit 1'

        self.create_app_version('test-app', '1.0', post_install=post_install_content)
        self.create_release('release-1.0', one_app_index(), 'test-app=1.0')

        self.sam.update('release-1.0')

        try:
            self.sam.install('test-app')
            assert False
        except Exception, e:
            assert True

        applications = self.sam.list()
        assert_single_application(applications, 'test-app', 'test app', '1.0', None)
